/*
  A defect, enhancement request, or other job specification.

  The actual fields in a job can be edited by a superuser in your system.
  The default set of fields in a system are Job, Status, User, Date, and Description.

*/
function JobCommand(data) {

    Object.defineProperties(this, {
        /*
          The job name.
        */
        "Job": {
            value: data ? data.Job : undefined,
            enumerable: true,
            writable: true
        }
    });

    var self = this;
    var keys = Object.keys(self);
    if (data) {
        Object.keys(data).forEach(function(dataKey) {
            if (!keys.find(function(k) { return k == dataKey; })) {
                self[dataKey] = data[dataKey];
            }
        });
    }
}

module.exports = JobCommand;
