/*
  A consolidated mechanism for identifying something that generally has a path in the system.

  Each location references either a depot, a dir, or a file.

*/
function Location(data) {

    Object.defineProperties(this, {
        /*
          An absolute depot path specification.
        */
        "depotPath": {
            value: data ? data.depotPath : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "depot": {
            value: data ? data.depot : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "dir": {
            value: data ? data.dir : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "file": {
            value: data ? data.file : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "fstat": {
            value: data ? data.fstat : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If this location indicates a single file, this can be set with the Base64-encoded content of the file.

        */
        "content": {
            value: data ? data.content : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = Location;
