var assert = require('assert');
var helix_web_services_client = require('../index.js');
var test_methods = require('./util/test_methods');
var string_methods = require('./util/string_methods');

var done = false;

test_methods.clientAsSuper(function (err, c) {
  if (err) {
    console.log("ERROR", err);
    assert(false);
  }

  var api = c.createDefaultApi();

  api.serverTriggersGet("localhost", function(err, triggers) {
    if (err) {
      console.log("ERROR", err);
      assert(false);
    }

    var originalLines = triggers.triggers? triggers.triggers : [];
    var lines = originalLines.splice(0);

    lines.push("cscheck change-submit //depot/... \"cmd %changelist%\"");

    var triggers = new helix_web_services_client.models.Triggers({
      triggers: lines
    });

    api.serverTriggersPut("localhost", triggers, function(err) {
      if (err) {
        console.log("ERROR", err);
        assert(false);
      }

      api.serverTriggersGet("localhost", function(err, saved) {
        if (err) {
          console.log("ERROR", err);
          assert(false);
        }

        assert(saved.triggers.find(function(t) { return t == "cscheck change-submit //depot/... \"cmd %changelist%\""; }) != null);

        var toClear = new helix_web_services_client.models.Triggers({
          triggers: originalLines
        });

        api.serverTriggersPut("localhost", toClear, function(err) {
          if (err) {
            console.log("ERROR", err);
            assert(false);
          }

          done = true;
        });
      });
    });
  });
});

function checkForDone() {
  if (!done) {
    setTimeout(checkForDone, 500);
  }
}

setTimeout(checkForDone, 0);
