<?php
/**
 * BranchCommand
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * BranchCommand Class Doc Comment
 *
 * @category    Class
 * @description Models the output of a `p4 branch` command.\n\nFor more information see the [command reference](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_branch.html).
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class BranchCommand implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'branch' => 'string',
        'owner' => 'string',
        'access' => '\DateTime',
        'update' => '\DateTime',
        'options' => 'string',
        'description' => 'string',
        'view' => 'string[]'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'branch' => 'branch',
        'owner' => 'owner',
        'access' => 'access',
        'update' => 'update',
        'options' => 'options',
        'description' => 'description',
        'view' => 'view'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'branch' => 'setBranch',
        'owner' => 'setOwner',
        'access' => 'setAccess',
        'update' => 'setUpdate',
        'options' => 'setOptions',
        'description' => 'setDescription',
        'view' => 'setView'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'branch' => 'getBranch',
        'owner' => 'getOwner',
        'access' => 'getAccess',
        'update' => 'getUpdate',
        'options' => 'getOptions',
        'description' => 'getDescription',
        'view' => 'getView'
    );

    
    /**
      * $branch The branch name, as provided on the command line.
      * @var string
      */
    protected $branch;
    
    /**
      * $owner The owner of the branch mapping.\nBy default, this will be set to the user who created the branch.\nThis field is unimportant unless the Option: field value is locked.
      * @var string
      */
    protected $owner;
    
    /**
      * $access The date the branch mapping was last accessed.
      * @var \DateTime
      */
    protected $access;
    
    /**
      * $update The date the branch mapping was last changed.
      * @var \DateTime
      */
    protected $update;
    
    /**
      * $options Either `unlocked` (the default) or `locked`.\n\nIf `locked`, only the `Owner:` can modify the branch mapping, and the mapping can't be deleted until it is `unlocked`.
      * @var string
      */
    protected $options;
    
    /**
      * $description A short description of the branch's purpose.
      * @var string
      */
    protected $description;
    
    /**
      * $view A set of mappings from one set of files in the depot (the source files) to another set of files in the depot (the target files).\n	The view maps from one location in the depot to another; it can't refer to a client workspace.\n\n  For example, the branch view `//depot/main/... //depot/r2.1/...` maps all the files under `//depot/main` to `//depot/r2.1`.
      * @var string[]
      */
    protected $view;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["branch"])) {
              $this->branch = $data["branch"];
            }
            if (isset($data["owner"])) {
              $this->owner = $data["owner"];
            }
            if (isset($data["access"])) {
              $this->access = $data["access"];
            }
            if (isset($data["update"])) {
              $this->update = $data["update"];
            }
            if (isset($data["options"])) {
              $this->options = $data["options"];
            }
            if (isset($data["description"])) {
              $this->description = $data["description"];
            }
            if (isset($data["view"])) {
              $this->view = $data["view"];
            }
        }
    }
    
    /**
     * Gets branch
     * @return string
     */
    public function getBranch()
    {
        return $this->branch;
    }

    /**
     * Sets branch
     * @param string $branch The branch name, as provided on the command line.
     * @return $this
     */
    public function setBranch($branch)
    {
        
        $this->branch = $branch;
        return $this;
    }
    
    /**
     * Gets owner
     * @return string
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Sets owner
     * @param string $owner The owner of the branch mapping.\nBy default, this will be set to the user who created the branch.\nThis field is unimportant unless the Option: field value is locked.
     * @return $this
     */
    public function setOwner($owner)
    {
        
        $this->owner = $owner;
        return $this;
    }
    
    /**
     * Gets access
     * @return \DateTime
     */
    public function getAccess()
    {
        return $this->access;
    }

    /**
     * Sets access
     * @param \DateTime $access The date the branch mapping was last accessed.
     * @return $this
     */
    public function setAccess($access)
    {
        
        $this->access = $access;
        return $this;
    }
    
    /**
     * Gets update
     * @return \DateTime
     */
    public function getUpdate()
    {
        return $this->update;
    }

    /**
     * Sets update
     * @param \DateTime $update The date the branch mapping was last changed.
     * @return $this
     */
    public function setUpdate($update)
    {
        
        $this->update = $update;
        return $this;
    }
    
    /**
     * Gets options
     * @return string
     */
    public function getOptions()
    {
        return $this->options;
    }

    /**
     * Sets options
     * @param string $options Either `unlocked` (the default) or `locked`.\n\nIf `locked`, only the `Owner:` can modify the branch mapping, and the mapping can't be deleted until it is `unlocked`.
     * @return $this
     */
    public function setOptions($options)
    {
        
        $this->options = $options;
        return $this;
    }
    
    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Sets description
     * @param string $description A short description of the branch's purpose.
     * @return $this
     */
    public function setDescription($description)
    {
        
        $this->description = $description;
        return $this;
    }
    
    /**
     * Gets view
     * @return string[]
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Sets view
     * @param string[] $view A set of mappings from one set of files in the depot (the source files) to another set of files in the depot (the target files).\n	The view maps from one location in the depot to another; it can't refer to a client workspace.\n\n  For example, the branch view `//depot/main/... //depot/r2.1/...` maps all the files under `//depot/main` to `//depot/r2.1`.
     * @return $this
     */
    public function setView($view)
    {
        
        $this->view = $view;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
