<?php
/**
 * ChangelistAction
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * ChangelistAction Class Doc Comment
 *
 * @category    Class
 * @description 
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ChangelistAction implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'depot_file' => 'string',
        'from_depot_file' => 'string',
        'action_type' => 'string',
        'content' => 'string',
        'require_version' => 'int'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'depot_file' => 'depotFile',
        'from_depot_file' => 'fromDepotFile',
        'action_type' => 'actionType',
        'content' => 'content',
        'require_version' => 'requireVersion'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'depot_file' => 'setDepotFile',
        'from_depot_file' => 'setFromDepotFile',
        'action_type' => 'setActionType',
        'content' => 'setContent',
        'require_version' => 'setRequireVersion'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'depot_file' => 'getDepotFile',
        'from_depot_file' => 'getFromDepotFile',
        'action_type' => 'getActionType',
        'content' => 'getContent',
        'require_version' => 'getRequireVersion'
    );

    
    /**
      * $depot_file The target file path to edit.
      * @var string
      */
    protected $depot_file;
    
    /**
      * $from_depot_file For \"branch\" or \"move\" actions, this indicates the source file location.
      * @var string
      */
    protected $from_depot_file;
    
    /**
      * $action_type One of \"upload\", \"branch\", \"move\", or \"delete\"
      * @var string
      */
    protected $action_type;
    
    /**
      * $content Base64-encoded content
      * @var string
      */
    protected $content;
    
    /**
      * $require_version If set, we will only operate if this is the current version of the file.
      * @var int
      */
    protected $require_version;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["depot_file"])) {
              $this->depot_file = $data["depot_file"];
            }
            if (isset($data["from_depot_file"])) {
              $this->from_depot_file = $data["from_depot_file"];
            }
            if (isset($data["action_type"])) {
              $this->action_type = $data["action_type"];
            }
            if (isset($data["content"])) {
              $this->content = $data["content"];
            }
            if (isset($data["require_version"])) {
              $this->require_version = $data["require_version"];
            }
        }
    }
    
    /**
     * Gets depot_file
     * @return string
     */
    public function getDepotFile()
    {
        return $this->depot_file;
    }

    /**
     * Sets depot_file
     * @param string $depot_file The target file path to edit.
     * @return $this
     */
    public function setDepotFile($depot_file)
    {
        
        $this->depot_file = $depot_file;
        return $this;
    }
    
    /**
     * Gets from_depot_file
     * @return string
     */
    public function getFromDepotFile()
    {
        return $this->from_depot_file;
    }

    /**
     * Sets from_depot_file
     * @param string $from_depot_file For \"branch\" or \"move\" actions, this indicates the source file location.
     * @return $this
     */
    public function setFromDepotFile($from_depot_file)
    {
        
        $this->from_depot_file = $from_depot_file;
        return $this;
    }
    
    /**
     * Gets action_type
     * @return string
     */
    public function getActionType()
    {
        return $this->action_type;
    }

    /**
     * Sets action_type
     * @param string $action_type One of \"upload\", \"branch\", \"move\", or \"delete\"
     * @return $this
     */
    public function setActionType($action_type)
    {
        
        $this->action_type = $action_type;
        return $this;
    }
    
    /**
     * Gets content
     * @return string
     */
    public function getContent()
    {
        return $this->content;
    }

    /**
     * Sets content
     * @param string $content Base64-encoded content
     * @return $this
     */
    public function setContent($content)
    {
        
        $this->content = $content;
        return $this;
    }
    
    /**
     * Gets require_version
     * @return int
     */
    public function getRequireVersion()
    {
        return $this->require_version;
    }

    /**
     * Sets require_version
     * @param int $require_version If set, we will only operate if this is the current version of the file.
     * @return $this
     */
    public function setRequireVersion($require_version)
    {
        
        $this->require_version = $require_version;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
