<?php

include 'util/test_config.php';
include 'util/string_utils.php';

$api = apiAsSuper();

$protections = $api->serverProtectionsGet('localhost');

assert(count($protections->getProtections()) >= 2);

$list = $protections->getProtections();

array_push($list, 'super user jdoe * //...');

$protections->setProtections($list);

$api->serverProtectionsPut('localhost', $protections);

$updated = $api->serverProtectionsGet('localhost');

assert(in_array('super user jdoe * //...', $updated->getProtections()));

array_pop($list);

$updated->setProtections($list);

$api->serverProtectionsPut('localhost', $updated);

$updated = $api->serverProtectionsGet('localhost');

assert(!in_array('super user jdoe * //...', $updated->getProtections()));
