<?php

include 'util/test_config.php';
include 'util/string_utils.php';

$api = apiAsSuper();

$triggers = $api->serverTriggersGet('localhost');

$list = $triggers->getTriggers();

$original_list = $list;

array_push($list, 'cscheck change-submit //depot/... "cmd %changelist%"');

$to_update = new HelixWebServices\Model\Triggers([
    "triggers" => $list
]);

$api->serverTriggersPut('localhost', $to_update);

$updated = $api->serverTriggersGet('localhost');

assert(in_array('cscheck change-submit //depot/... "cmd %changelist%"', $updated->getTriggers()));

$to_clear = new HelixWebServices\Model\Triggers([
    "triggers" => $original_list
]);

$api->serverTriggersPut('localhost', $to_clear);

$cleared = $api->serverTriggersGet('localhost');

assert(!in_array('cscheck change-submit //depot/... "cmd %changelist%"', $cleared->getTriggers()));


