# Common files
require 'helix_web_services_client/api_client'
require 'helix_web_services_client/api_error'
require 'helix_web_services_client/version'
require 'helix_web_services_client/configuration'

# Models
require 'helix_web_services_client/models/branch_command'
require 'helix_web_services_client/models/branches_command'
require 'helix_web_services_client/models/change_command'
require 'helix_web_services_client/models/changes_command'
require 'helix_web_services_client/models/changelist_request'
require 'helix_web_services_client/models/changelist_action'
require 'helix_web_services_client/models/client_command'
require 'helix_web_services_client/models/clients_command'
require 'helix_web_services_client/models/command_response'
require 'helix_web_services_client/models/command_request'
require 'helix_web_services_client/models/counter'
require 'helix_web_services_client/models/depot_command'
require 'helix_web_services_client/models/depots_command'
require 'helix_web_services_client/models/dirs_command'
require 'helix_web_services_client/models/files_command'
require 'helix_web_services_client/models/fstat_command'
require 'helix_web_services_client/models/git_fusion_repo_id'
require 'helix_web_services_client/models/git_fusion_repo_config'
require 'helix_web_services_client/models/git_fusion_repo_branch_config'
require 'helix_web_services_client/models/git_fusion_repo_global_overrides'
require 'helix_web_services_client/models/group_command'
require 'helix_web_services_client/models/groups_command'
require 'helix_web_services_client/models/hws_status'
require 'helix_web_services_client/models/labels_command'
require 'helix_web_services_client/models/label_command'
require 'helix_web_services_client/models/location'
require 'helix_web_services_client/models/login_request'
require 'helix_web_services_client/models/server_login_request'
require 'helix_web_services_client/models/login_response'
require 'helix_web_services_client/models/p4d_config_id'
require 'helix_web_services_client/models/protections'
require 'helix_web_services_client/models/servers_command'
require 'helix_web_services_client/models/server_command'
require 'helix_web_services_client/models/stream_command'
require 'helix_web_services_client/models/streams_command'
require 'helix_web_services_client/models/triggers'
require 'helix_web_services_client/models/user_command'
require 'helix_web_services_client/models/users_command'
# Custom models
require 'helix_web_services_client/models/job_command'
require 'helix_web_services_client/models/jobs_command'

# APIs
require 'helix_web_services_client/api/alpha_api'
require 'helix_web_services_client/api/default_api'

module HelixWebServices
  class << self
    # Customize default settings for the SDK using block.
    #   HelixWebServices.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
